freedombone-app-matrix 23KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654
  1. #!/bin/bash
  2. #
  3. # .---. . .
  4. # | | |
  5. # |--- .--. .-. .-. .-.| .-. .--.--. |.-. .-. .--. .-.
  6. # | | (.-' (.-' ( | ( )| | | | )( )| | (.-'
  7. # ' ' --' --' -' - -' ' ' -' -' -' ' - --'
  8. #
  9. # Freedom in the Cloud
  10. #
  11. # matrix server
  12. #
  13. # https://raw.githubusercontent.com/silvio/docker-matrix
  14. #
  15. # License
  16. # =======
  17. #
  18. # Copyright (C) 2016 Bob Mottram <bob@freedombone.net>
  19. #
  20. # This program is free software: you can redistribute it and/or modify
  21. # it under the terms of the GNU Affero General Public License as published by
  22. # the Free Software Foundation, either version 3 of the License, or
  23. # (at your option) any later version.
  24. #
  25. # This program is distributed in the hope that it will be useful,
  26. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  27. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  28. # GNU Affero General Public License for more details.
  29. #
  30. # You should have received a copy of the GNU Affero General Public License
  31. # along with this program. If not, see <http://www.gnu.org/licenses/>.
  32. VARIANTS='full full-vim chat'
  33. IN_DEFAULT_INSTALL=0
  34. SHOW_ON_ABOUT=1
  35. MATRIX_DATA_DIR='/var/lib/matrix'
  36. MATRIX_PORT=8448
  37. MATRIX_ID_PORT=8081
  38. MATRIX_REPO="https://github.com/matrix-org/synapse"
  39. MATRIX_COMMIT='f5a4001bb116c468cc5e8e0ae04a1c570e2cb171'
  40. SYDENT_REPO="https://github.com/matrix-org/sydent"
  41. SYDENT_COMMIT='99edbd4c80c42b76e26f696054fcbbceecb25d5f'
  42. REPORT_STATS="no"
  43. MATRIX_SECRET=
  44. matrix_variables=(ONION_ONLY
  45. MY_USERNAME
  46. MATRIX_SECRET
  47. DEFAULT_DOMAIN_NAME)
  48. function matrix_nginx {
  49. matrix_identityserver_proxy_str=' \
  50. location /matrixid { \
  51. proxy_pass http://localhost:8081; \
  52. proxy_buffering on; \
  53. }'
  54. matrix_proxy_str=' \
  55. location /matrix { \
  56. proxy_pass https://localhost:8448; \
  57. proxy_buffering on; \
  58. }'
  59. turn_proxy_str=' \
  60. location /turn { \
  61. proxy_pass https://localhost:3478; \
  62. proxy_buffering on; \
  63. }'
  64. if [[ $ONION_ONLY != 'no' ]]; then
  65. matrix_proxy_str=' \
  66. location /matrix { \
  67. proxy_pass http://localhost:8448; \
  68. proxy_buffering on; \
  69. }'
  70. turn_proxy_str=' \
  71. location /turn { \
  72. proxy_pass http://localhost:3478; \
  73. proxy_buffering on; \
  74. }'
  75. fi
  76. if [ ! -f /etc/nginx/sites-available/${DEFAULT_DOMAIN_NAME} ]; then
  77. matrix_nginx_site=/etc/nginx/sites-available/$DEFAULT_DOMAIN_NAME
  78. if [[ $ONION_ONLY == "no" ]]; then
  79. function_check nginx_http_redirect
  80. nginx_http_redirect $DEFAULT_DOMAIN_NAME
  81. echo 'server {' >> $matrix_nginx_site
  82. echo ' listen 443 ssl;' >> $matrix_nginx_site
  83. echo ' listen [::]:443 ssl;' >> $matrix_nginx_site
  84. echo " server_name $DEFAULT_DOMAIN_NAME;" >> $matrix_nginx_site
  85. echo '' >> $matrix_nginx_site
  86. echo ' # Security' >> $matrix_nginx_site
  87. function_check nginx_ssl
  88. nginx_ssl $DEFAULT_DOMAIN_NAME
  89. function_check nginx_disable_sniffing
  90. nginx_disable_sniffing $DEFAULT_DOMAIN_NAME
  91. echo ' add_header Strict-Transport-Security max-age=15768000;' >> $matrix_nginx_site
  92. echo '' >> $matrix_nginx_site
  93. echo ' # Logs' >> $matrix_nginx_site
  94. echo ' access_log /dev/null;' >> $matrix_nginx_site
  95. echo ' error_log /dev/null;' >> $matrix_nginx_site
  96. echo '' >> $matrix_nginx_site
  97. echo ' # Root' >> $matrix_nginx_site
  98. echo " root /var/www/$DEFAULT_DOMAIN_NAME/htdocs;" >> $matrix_nginx_site
  99. echo '' >> $matrix_nginx_site
  100. echo ' # Index' >> $matrix_nginx_site
  101. echo ' index index.html;' >> $matrix_nginx_site
  102. echo '' >> $matrix_nginx_site
  103. echo ' # Location' >> $matrix_nginx_site
  104. echo ' location / {' >> $matrix_nginx_site
  105. function_check nginx_limits
  106. nginx_limits $DEFAULT_DOMAIN_NAME '15m'
  107. echo ' }' >> $matrix_nginx_site
  108. echo '' >> $matrix_nginx_site
  109. echo ' # Restrict access that is unnecessary anyway' >> $matrix_nginx_site
  110. echo ' location ~ /\.(ht|git) {' >> $matrix_nginx_site
  111. echo ' deny all;' >> $matrix_nginx_site
  112. echo ' }' >> $matrix_nginx_site
  113. echo '}' >> $matrix_nginx_site
  114. else
  115. echo -n '' > $matrix_nginx_site
  116. fi
  117. echo 'server {' >> $matrix_nginx_site
  118. echo " listen 127.0.0.1:$MATRIX_PORT default_server;" >> $matrix_nginx_site
  119. echo " server_name $DEFAULT_DOMAIN_NAME;" >> $matrix_nginx_site
  120. echo '' >> $matrix_nginx_site
  121. function_check nginx_disable_sniffing
  122. nginx_disable_sniffing $DEFAULT_DOMAIN_NAME
  123. echo '' >> $matrix_nginx_site
  124. echo ' # Logs' >> $matrix_nginx_site
  125. echo ' access_log /dev/null;' >> $matrix_nginx_site
  126. echo ' error_log /dev/null;' >> $matrix_nginx_site
  127. echo '' >> $matrix_nginx_site
  128. echo ' # Root' >> $matrix_nginx_site
  129. echo " root /var/www/$DEFAULT_DOMAIN_NAME/htdocs;" >> $matrix_nginx_site
  130. echo '' >> $matrix_nginx_site
  131. echo ' # Location' >> $matrix_nginx_site
  132. echo ' location / {' >> $matrix_nginx_site
  133. function_check nginx_limits
  134. nginx_limits $DEFAULT_DOMAIN_NAME '15m'
  135. echo ' }' >> $matrix_nginx_site
  136. echo '' >> $matrix_nginx_site
  137. echo ' # Restrict access that is unnecessary anyway' >> $matrix_nginx_site
  138. echo ' location ~ /\.(ht|git) {' >> $matrix_nginx_site
  139. echo ' deny all;' >> $matrix_nginx_site
  140. echo ' }' >> $matrix_nginx_site
  141. echo '}' >> $matrix_nginx_site
  142. if [ ! -f /etc/ssl/certs/${DEFAULT_DOMAIN_NAME}.pem ]; then
  143. function_check create_site_certificate
  144. create_site_certificate $DEFAULT_DOMAIN_NAME 'yes'
  145. fi
  146. nginx_ensite $DEFAULT_DOMAIN_NAME
  147. fi
  148. if ! grep "localhost:${MATRIX_ID_PORT}" /etc/nginx/sites-available/${DEFAULT_DOMAIN_NAME}; then
  149. sed -i "s|:443 ssl;|:443 ssl;${matrix_identityserver_proxy_str}|g" /etc/nginx/sites-available/${DEFAULT_DOMAIN_NAME}
  150. sed -i "s| default_server;| default_server;${matrix_identityserver_proxy_str}|g" /etc/nginx/sites-available/${DEFAULT_DOMAIN_NAME}
  151. fi
  152. if ! grep "localhost:${MATRIX_PORT}" /etc/nginx/sites-available/${DEFAULT_DOMAIN_NAME}; then
  153. sed -i "s|:443 ssl;|:443 ssl;${matrix_proxy_str}|g" /etc/nginx/sites-available/${DEFAULT_DOMAIN_NAME}
  154. sed -i "s| default_server;| default_server;${matrix_proxy_str}|g" /etc/nginx/sites-available/${DEFAULT_DOMAIN_NAME}
  155. fi
  156. if ! grep "localhost:${TURN_PORT}" /etc/nginx/sites-available/${DEFAULT_DOMAIN_NAME}; then
  157. sed -i "s|:443 ssl;|:443 ssl;${turn_proxy_str}|g" /etc/nginx/sites-available/${DEFAULT_DOMAIN_NAME}
  158. sed -i "s| default_server;| default_server;${turn_proxy_str}|g" /etc/nginx/sites-available/${DEFAULT_DOMAIN_NAME}
  159. fi
  160. systemctl restart nginx
  161. # wait for nginx to start otherwise user add fails later
  162. sleep 5
  163. }
  164. function matrix_generate_homeserver_file {
  165. local filepath="${1}"
  166. cd /etc/matrix
  167. python -m synapse.app.homeserver \
  168. --config-path "${filepath}" \
  169. --generate-config \
  170. --report-stats ${REPORT_STATS} \
  171. --server-name ${DEFAULT_DOMAIN_NAME}
  172. }
  173. function matrix_generate_identityserver_file {
  174. local filepath="${1}"
  175. cd /etc/sydent
  176. python -m sydent.sydent \
  177. --config-path "${filepath}" \
  178. --generate-config \
  179. --report-stats ${REPORT_STATS} \
  180. --server-name ${DEFAULT_DOMAIN_NAME}
  181. }
  182. function matrix_configure_homeserver_yaml {
  183. local turnkey="${1}"
  184. local filepath="${2}"
  185. local ymltemp="$(mktemp)"
  186. awk -v TURNURIES="turn_uris: [\"turn:${DEFAULT_DOMAIN_NAME}/turn?transport=udp\", \"turn:${DEFAULT_DOMAIN_NAME}/turn?transport=tcp\"]" \
  187. -v TURNSHAREDSECRET="turn_shared_secret: \"${turnkey}\"" \
  188. -v PIDFILE="pid_file: ${MATRIX_DATA_DIR}/homeserver.pid" \
  189. -v DATABASE="database: \"${MATRIX_DATA_DIR}/homeserver.db\"" \
  190. -v LOGFILE="log_file: \"/dev/null\"" \
  191. -v MEDIASTORE="media_store_path: \"${MATRIX_DATA_DIR}/media_store\"" \
  192. '{
  193. sub(/turn_shared_secret: "YOUR_SHARED_SECRET"/, TURNSHAREDSECRET);
  194. sub(/turn_uris: \[\]/, TURNURIES);
  195. sub(/pid_file: \/homeserver.pid/, PIDFILE);
  196. sub(/database: "\/homeserver.db"/, DATABASE);
  197. sub(/log_file: "\/homeserver.log"/, LOGFILE);
  198. sub(/media_store_path: "\/media_store"/, MEDIASTORE);
  199. print;
  200. }' "${filepath}" > "${ymltemp}"
  201. mv ${ymltemp} "${filepath}"
  202. if [[ $ONION_ONLY != 'no' ]]; then
  203. sed -i 's|no_tls: .*|no_tls: True|g' "${filepath}"
  204. fi
  205. sed -i 's|enable_registration_captcha.*|enable_registration_captcha: False|g' "${filepath}"
  206. sed -i "s|database: \".*|database: \"${MATRIX_DATA_DIR}/homeserver.db\"|g" "${filepath}"
  207. sed -i "s|media_store_path:.*|media_store_path: \"${MATRIX_DATA_DIR}/media_store\"|g" "${filepath}"
  208. sed -i "s|pid_file:.*|pid_file: \"${MATRIX_DATA_DIR}/homeserver.pid\"|g" "${filepath}"
  209. sed -i "s|log_file:.*|log_file: \"/dev/null\"|g" "${filepath}"
  210. sed -i '0,/bind_address:.*/s//bind_address: 127.0.0.1/' "${filepath}"
  211. sed -i '0,/x_forwarded:.*/s//x_forwarded: true/' "${filepath}"
  212. }
  213. function matrix_configure_identityserver {
  214. local filepath=/etc/sydent/sydent.conf
  215. sed -i "s|http.port.*|http.port = $MATRIX_ID_PORT|g" ${filepath}
  216. sed -i "s|db.file.*|db.file = /etc/sydent/sydent.db|g" ${filepath}
  217. sed -i "s|Sydent Validation|Freedombone Matrix Account Validation|g" ${filepath}
  218. sed -i "s|pidfile.path.*|pidfile.path = /etc/sydent/sydent.pid|g" ${filepath}
  219. sed -i "s|log.path.*|log.path = /dev/null|g" ${filepath}
  220. sed -i "s|server.name.*|server.name = ${DEFAULT_DOMAIN_NAME}|g" ${filepath}
  221. }
  222. function matrix_diff {
  223. DIFFPARAMS="${DIFFPARAMS:-Naur}"
  224. DEFAULT_DOMAIN_NAME="${DEFAULT_DOMAIN_NAME:-demo_server_name}"
  225. REPORT_STATS="${REPORT_STATS:-no_or_yes}"
  226. export DEFAULT_DOMAIN_NAME REPORT_STATS
  227. matrix_generate_synapse_file $INSTALL_DIR/homeserver.synapse.yaml
  228. diff -${DIFFPARAMS} $INSTALL_DIR/homeserver.synapse.yaml ${MATRIX_DATA_DIR}/homeserver.yaml
  229. rm $INSTALL_DIR/homeserver.synapse.yaml
  230. }
  231. function matrix_generate {
  232. breakup="0"
  233. [[ -z "${DEFAULT_DOMAIN_NAME}" ]] && echo "STOP! environment variable DEFAULT_DOMAIN_NAME must be set" && breakup="1"
  234. [[ -z "${REPORT_STATS}" ]] && echo "STOP! environment variable REPORT_STATS must be set to 'no' or 'yes'" && breakup="1"
  235. [[ "${breakup}" == "1" ]] && exit 1
  236. [[ "${REPORT_STATS}" != "yes" ]] && [[ "${REPORT_STATS}" != "no" ]] && \
  237. echo "STOP! REPORT_STATS needs to be 'no' or 'yes'" && breakup="1"
  238. homeserver_config=${MATRIX_DATA_DIR}/homeserver.yaml
  239. if [ -f $homeserver_config ]; then
  240. rm $homeserver_config
  241. fi
  242. matrix_generate_homeserver_file $homeserver_config
  243. matrix_configure_homeserver_yaml "${turnkey}" $homeserver_config
  244. }
  245. function remove_user_matrix {
  246. remove_username="$1"
  247. ${PROJECT_NAME}-pass -u $remove_username --rmapp matrix
  248. # TODO: There is no user removal script within synapse
  249. }
  250. function add_user_matrix {
  251. new_username="$1"
  252. new_user_password="$2"
  253. ${PROJECT_NAME}-pass -u $new_username -a matrix -p "$new_user_password"
  254. retval=$(register_new_matrix_user -c ${MATRIX_DATA_DIR}/homeserver.yaml -u "${new_username}" -p "${new_user_password}" -a)
  255. echo "0"
  256. }
  257. function install_interactive_matrix {
  258. APP_INSTALLED=1
  259. }
  260. function change_password_matrix {
  261. curr_username="$1"
  262. new_user_password="$2"
  263. #${PROJECT_NAME}-pass -u "$curr_username" -a matrix -p "$new_user_password"
  264. }
  265. function reconfigure_matrix {
  266. echo -n ''
  267. }
  268. function upgrade_matrix {
  269. function_check set_repo_commit
  270. set_repo_commit /etc/matrix "matrix commit" "$MATRIX_COMMIT" $MATRIX_REPO
  271. cd /etc/matrix
  272. pip install --upgrade --process-dependency-links .
  273. set_repo_commit /etc/sydent "sydent commit" "$SYDENT_COMMIT" $SYDENT_REPO
  274. cd /etc/sydent
  275. pip install --upgrade --process-dependency-links .
  276. sed -i 's|ssl.PROTOCOL_SSLv23|ssl.PROTOCOL_TLSv1|g' /usr/local/bin/register_new_matrix_user
  277. chown -R matrix:matrix /etc/matrix
  278. chown -R matrix:matrix /etc/sydent
  279. chown -R matrix:matrix $MATRIX_DATA_DIR
  280. }
  281. function backup_local_matrix {
  282. source_directory=/etc/matrix
  283. if [ -d $source_directory ]; then
  284. systemctl stop matrix
  285. function_check backup_directory_to_usb
  286. backup_directory_to_usb $source_directory matrix
  287. source_directory=$MATRIX_DATA_DIR
  288. if [ -d $source_directory ]; then
  289. backup_directory_to_usb $source_directory matrixdata
  290. fi
  291. systemctl start matrix
  292. fi
  293. }
  294. function restore_local_matrix {
  295. if [ -d /etc/matrix ]; then
  296. systemctl stop matrix
  297. temp_restore_dir=/root/tempmatrix
  298. function_check restore_directory_from_usb
  299. restore_directory_from_usb $temp_restore_dir matrix
  300. cp -r $temp_restore_dir/etc/matrix/* /etc/matrix
  301. if [ ! "$?" = "0" ]; then
  302. function_check backup_unmount_drive
  303. backup_unmount_drive
  304. exit 3783
  305. fi
  306. rm -rf $temp_restore_dir
  307. chown -R matrix:matrix /etc/matrix
  308. temp_restore_dir=/root/tempmatrixdata
  309. restore_directory_from_usb $temp_restore_dir matrixdata
  310. cp -r $temp_restore_dir$MATRIX_DATA_DIR/* $MATRIX_DATA_DIR
  311. if [ ! "$?" = "0" ]; then
  312. function_check backup_unmount_drive
  313. backup_unmount_drive
  314. exit 78352
  315. fi
  316. rm -rf $temp_restore_dir
  317. chown -R matrix:matrix $MATRIX_DATA_DIR
  318. systemctl start matrix
  319. fi
  320. }
  321. function backup_remote_matrix {
  322. source_directory=/etc/matrix
  323. if [ -d $source_directory ]; then
  324. systemctl stop matrix
  325. function_check backup_directory_to_friend
  326. backup_directory_to_friend $source_directory matrix
  327. source_directory=$MATRIX_DATA_DIR
  328. if [ -d $source_directory ]; then
  329. backup_directory_to_friend $source_directory matrixdata
  330. fi
  331. systemctl start matrix
  332. fi
  333. }
  334. function restore_remote_matrix {
  335. if [ -d /etc/matrix ]; then
  336. systemctl stop matrix
  337. temp_restore_dir=/root/tempmatrix
  338. function_check restore_directory_from_friend
  339. restore_directory_from_friend $temp_restore_dir matrix
  340. cp -r $temp_restore_dir/etc/matrix/* /etc/matrix
  341. if [ ! "$?" = "0" ]; then
  342. exit 38935
  343. fi
  344. rm -rf $temp_restore_dir
  345. chown -R matrix:matrix /etc/matrix
  346. temp_restore_dir=/root/tempmatrixdata
  347. restore_directory_from_friend $temp_restore_dir matrixdata
  348. cp -r $temp_restore_dir$MATRIX_DATA_DIR/* $MATRIX_DATA_DIR
  349. if [ ! "$?" = "0" ]; then
  350. exit 60923
  351. fi
  352. rm -rf $temp_restore_dir
  353. chown -R matrix:matrix $MATRIX_DATA_DIR
  354. systemctl start matrix
  355. fi
  356. }
  357. function remove_matrix {
  358. firewall_remove ${MATRIX_PORT}
  359. systemctl stop matrix
  360. systemctl stop sydent
  361. function_check remove_turn
  362. remove_turn
  363. systemctl disable matrix
  364. systemctl disable sydent
  365. if [ -f /etc/systemd/system/matrix.service ]; then
  366. rm /etc/systemd/system/matrix.service
  367. fi
  368. if [ -f /etc/systemd/system/sydent.service ]; then
  369. rm /etc/systemd/system/sydent.service
  370. fi
  371. apt-get -y remove --purge coturn
  372. cd /etc/matrix
  373. pip uninstall .
  374. cd /etc/sydent
  375. pip uninstall .
  376. rm -rf $MATRIX_DATA_DIR
  377. rm -rf /etc/matrix
  378. rm -rf /etc/sydent
  379. deluser matrix
  380. delgroup matrix
  381. remove_onion_service matrix ${MATRIX_PORT}
  382. sed -i "/location \/matrix {/,/}/d" /etc/nginx/sites-available/${DEFAULT_DOMAIN_NAME}
  383. sed -i "/location \/matrixid {/,/}/d" /etc/nginx/sites-available/${DEFAULT_DOMAIN_NAME}
  384. sed -i "/location \/turn {/,/}/d" /etc/nginx/sites-available/${DEFAULT_DOMAIN_NAME}
  385. systemctl restart nginx
  386. remove_completion_param install_matrix
  387. sed -i '/matrix/d' $COMPLETION_FILE
  388. }
  389. function install_identity_server {
  390. if [ ! -d /etc/sydent ]; then
  391. function_check git_clone
  392. git_clone $SYDENT_REPO /etc/sydent
  393. if [ ! -d /etc/sydent ]; then
  394. echo $'Unable to clone sydent repo'
  395. exit 936525
  396. fi
  397. fi
  398. cd /etc/sydent
  399. git checkout $SYDENT_COMMIT -b $SYDENT_COMMIT
  400. set_completion_param "sydent commit" "$SYDENT_COMMIT"
  401. if [ ! -d $INSTALL_DIR/sydent ]; then
  402. mkdir -p $INSTALL_DIR/sydent
  403. fi
  404. pip install --upgrade --process-dependency-links . -b $INSTALL_DIR/sydent
  405. if [ ! "$?" = "0" ]; then
  406. echo $'Failed to install matrix identity server'
  407. exit 798362
  408. fi
  409. function_check matrix_generate_identityserver_file
  410. matrix_generate_identityserver_file /etc/sydent/sydent.conf
  411. if [ ! -f /etc/sydent/sydent.conf ]; then
  412. echo $'Matrix identity server configuration not generated'
  413. exit 72528
  414. fi
  415. function_check matrix_configure_identityserver
  416. matrix_configure_identityserver
  417. if [ ! -f /etc/sydent/sydent.conf ]; then
  418. echo $'Matrix identity server config was not generated'
  419. exit 82352
  420. fi
  421. chmod -R 700 /etc/sydent/sydent.conf
  422. chown -R matrix:matrix /etc/sydent
  423. echo '[Unit]' > /etc/systemd/system/sydent.service
  424. echo 'Description=Sydent Matrix identity server' >> /etc/systemd/system/sydent.service
  425. echo 'After=network.target nginx.target' >> /etc/systemd/system/sydent.service
  426. echo '' >> /etc/systemd/system/sydent.service
  427. echo '[Service]' >> /etc/systemd/system/sydent.service
  428. echo 'Type=simple' >> /etc/systemd/system/sydent.service
  429. echo 'User=matrix' >> /etc/systemd/system/sydent.service
  430. echo "WorkingDirectory=/etc/sydent" >> /etc/systemd/system/sydent.service
  431. echo "ExecStart=/usr/bin/python -m sydent.sydent --config-path /etc/sydent/sydent.conf" >> /etc/systemd/system/sydent.service
  432. echo 'Restart=always' >> /etc/systemd/system/sydent.service
  433. echo 'RestartSec=10' >> /etc/systemd/system/sydent.service
  434. echo '' >> /etc/systemd/system/sydent.service
  435. echo '[Install]' >> /etc/systemd/system/sydent.service
  436. echo 'WantedBy=multi-user.target' >> /etc/systemd/system/sydent.service
  437. systemctl enable sydent
  438. systemctl daemon-reload
  439. systemctl start sydent
  440. if [ ! -f /etc/sydent/sydent.db ]; then
  441. echo $'No matrix identity server database was created'
  442. exit 7354383
  443. fi
  444. chmod -R 700 /etc/sydent/sydent.db
  445. }
  446. function install_home_server {
  447. if [ ! -d /etc/matrix ]; then
  448. function_check git_clone
  449. git_clone $MATRIX_REPO /etc/matrix
  450. if [ ! -d /etc/matrix ]; then
  451. echo $'Unable to clone matrix repo'
  452. exit 6724683
  453. fi
  454. fi
  455. cd /etc/matrix
  456. git checkout $MATRIX_COMMIT -b $MATRIX_COMMIT
  457. set_completion_param "matrix commit" "$MATRIX_COMMIT"
  458. if [ ! -d $INSTALL_DIR/matrix ]; then
  459. mkdir -p $INSTALL_DIR/matrix
  460. fi
  461. pip install --upgrade --process-dependency-links . -b $INSTALL_DIR/matrix
  462. if [ ! "$?" = "0" ]; then
  463. echo $'Failed to install matrix home server'
  464. exit 782542
  465. fi
  466. if [ ! -d $MATRIX_DATA_DIR ]; then
  467. mkdir $MATRIX_DATA_DIR
  468. fi
  469. groupadd matrix
  470. useradd -c "Matrix system account" -d $MATRIX_DATA_DIR -m -r -g matrix matrix
  471. function_check install_turn
  472. install_turn
  473. MATRIX_SECRET="${turnkey}"
  474. function_check matrix_generate
  475. matrix_generate
  476. if [[ -z ${MATRIX_DATA_DIR}/homeserver.yaml ]]; then
  477. echo $'homeserver.yaml is zero size'
  478. exit 783724
  479. fi
  480. chmod -R 700 $MATRIX_DATA_DIR/homeserver.yaml
  481. chown -R matrix:matrix /etc/matrix
  482. chown -R matrix:matrix $MATRIX_DATA_DIR
  483. sed -i 's|ssl.PROTOCOL_SSLv23|ssl.PROTOCOL_TLSv1|g' /usr/local/bin/register_new_matrix_user
  484. echo '[Unit]' > /etc/systemd/system/matrix.service
  485. echo 'Description=Synapse Matrix homeserver' >> /etc/systemd/system/matrix.service
  486. echo 'After=network.target nginx.target' >> /etc/systemd/system/matrix.service
  487. echo '' >> /etc/systemd/system/matrix.service
  488. echo '[Service]' >> /etc/systemd/system/matrix.service
  489. echo 'Type=simple' >> /etc/systemd/system/matrix.service
  490. echo 'User=matrix' >> /etc/systemd/system/matrix.service
  491. echo "WorkingDirectory=/etc/matrix" >> /etc/systemd/system/matrix.service
  492. echo "ExecStart=/usr/bin/python -m synapse.app.homeserver --config-path ${MATRIX_DATA_DIR}/homeserver.yaml" >> /etc/systemd/system/matrix.service
  493. echo 'Restart=always' >> /etc/systemd/system/matrix.service
  494. echo 'RestartSec=10' >> /etc/systemd/system/matrix.service
  495. echo '' >> /etc/systemd/system/matrix.service
  496. echo '[Install]' >> /etc/systemd/system/matrix.service
  497. echo 'WantedBy=multi-user.target' >> /etc/systemd/system/matrix.service
  498. systemctl enable matrix
  499. systemctl daemon-reload
  500. systemctl start matrix
  501. if [ ! -f $MATRIX_DATA_DIR/homeserver.db ]; then
  502. echo $'No matrix home server database was created'
  503. fi
  504. chmod -R 700 $MATRIX_DATA_DIR/homeserver.db
  505. firewall_add matrix ${MATRIX_PORT}
  506. MATRIX_ONION_HOSTNAME=$(add_onion_service matrix ${MATRIX_PORT} ${MATRIX_PORT})
  507. if [ ! ${MATRIX_PASSWORD} ]; then
  508. if [ -f ${IMAGE_PASSWORD_FILE} ]; then
  509. MATRIX_PASSWORD="$(printf `cat $IMAGE_PASSWORD_FILE`)"
  510. else
  511. MATRIX_PASSWORD="$(create_password ${MINIMUM_PASSWORD_LENGTH})"
  512. fi
  513. fi
  514. rm -rf ${MATRIX_DATA_DIR}/Maildir
  515. rm -rf ${MATRIX_DATA_DIR}/.mutt
  516. rm -f ${MATRIX_DATA_DIR}/.muttrc
  517. rm -f ${MATRIX_DATA_DIR}/.mutt-alias
  518. rm -f ${MATRIX_DATA_DIR}/.procmailrc
  519. rm -f ${MATRIX_DATA_DIR}/.emacs-mutt
  520. }
  521. function install_matrix {
  522. if [ ! -d $INSTALL_DIR ]; then
  523. mkdir -p $INSTALL_DIR
  524. fi
  525. if [[ ${ONION_ONLY} == 'no' ]]; then
  526. if [ ! -f /etc/ssl/certs/${DEFAULT_DOMAIN_NAME}.pem ]; then
  527. echo $'Obtaining certificate for the main domain'
  528. create_site_certificate ${DEFAULT_DOMAIN_NAME} 'yes'
  529. fi
  530. fi
  531. export DEBIAN_FRONTEND=noninteractive
  532. apt-get -yq install coreutils \
  533. curl file gcc git libevent-2.0-5 \
  534. libevent-dev libffi-dev libffi6 \
  535. libgnutls28-dev libjpeg62-turbo \
  536. libjpeg62-turbo-dev libldap-2.4-2 \
  537. libldap2-dev libsasl2-dev \
  538. libsqlite3-dev libssl-dev \
  539. libssl1.0.0 libtool libxml2 \
  540. libxml2-dev libxslt1-dev libxslt1.1 \
  541. make python python-dev \
  542. python-pip python-psycopg2 \
  543. python-virtualenv sqlite unzip \
  544. zlib1g zlib1g-dev
  545. pip install --upgrade pip
  546. pip install --upgrade python-ldap
  547. pip install --upgrade lxml
  548. pip install --upgrade --force "pynacl==0.3.0"
  549. function_check install_home_server
  550. install_home_server
  551. function_check install_identity_server
  552. install_identity_server
  553. function_check update_default_domain
  554. update_default_domain
  555. function_check matrix_nginx
  556. matrix_nginx
  557. if [[ $(add_user_matrix "${MY_USERNAME}" "${MATRIX_PASSWORD}" | tail -n 1) != "0" ]]; then
  558. echo $'Failed to add matrix admin user';
  559. exit 879352
  560. fi
  561. APP_INSTALLED=1
  562. }